const request = require("request")
const BotClient = require(".../BotClient.js")

class getUserChannels {
    constructor(pagesize, pagetoken){
     this.pagesize = pagesize
     this.pagetoken = pagetoken
    }
}

const form = {
    method: "GET",
    url: `https://api.zoom.us/v2/chat/users/me/channels`,
    headers: {
        'Authorization': BotClient.token,
        'content-type': 'application/json'
      }
}

function callback(error, response, body) {
    if(response.statusCode == 400){
    throw Error("400 Bad Request")
    }
    if(response.statusCode == 404){
     throw Error("404 Not found.")
    }
    if(response.statusCode == 300){
        throw Error("300 The next page token is either invalid or has expired.")
       }
  }

request(form, callback).on("response",response =>{
    const body = JSON.parse(response.body)
    if(body.channels.map().type == 1) var tp = "private_channel"
    if(body.channels.map().type == 2) var tp = "private_group_channel"
    if(body.channels.map().type == 3) var tp ="public_channel"
    if(body.channels.map().type == 4) var tp ="new_channel"
    const responser = {
        totalrecords = body.total_records,
        page_size = body.page_size,
        nextpageToken = body.next_page_token,
        channels = [
            body.channels.map(),
            id = body.channels.map().id,
            name = body.channels.map().name,
            type = tp
        ]
    }
    return responser
})

module.exports = getUserChannels